"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Account = void 0;
const common_1 = require("../common");
const account_created_event_1 = require("./account-created.event");
const account_status_1 = require("./account-status");
const constants_1 = require("./constants");
class Account extends (0, common_1.Aggregate)(constants_1.Aggregates.Account) {
    validateProps(props) { }
    static create(props) {
        const newAccount = common_1.AggregateBuilder.new(Account, Object.assign(Object.assign({}, props), { status: account_status_1.AccountStatus.ActivatePending }));
        newAccount.recordEvent(common_1.DomainEventBuilder.new(account_created_event_1.AccountCreatedEvent, newAccount.id, {
            accountId: newAccount.id,
            username: newAccount.username,
        }));
        return newAccount;
    }
    get username() {
        return this._props.username;
    }
    get password() {
        return this._props.password;
    }
    get status() {
        return this._props.status;
    }
}
exports.Account = Account;
